

Metropolis <- function(
data,
loglik,
logprior,
gibbs,
trans,
theta0,
MS.scale,
MS.adj=200,
MS.block=1,
MS.size,
MS.low=NA,
MS.high=NA,
MS.names=NA,
MS.screen=NA,
MS.screen.dig=6,
software="R")
{

Input <- list(
data,loglik,logprior,trans,theta.first=theta0,MS.size=MS.size,MS.block=MS.block,MS.low=MS.low,MS.high=MS.high,MS.scale=MS.scale,MS.adj=MS.adj,MS.names=MS.names)
	
if (is.list(theta0)) 	theta0 <- ListToMatrix(theta0)
if (is.list(MS.scale)) MS.scale <- ListToMatrix(MS.scale)
if (is.list(MS.low)) MS.low <- ListToMatrix(MS.low)
if (is.list(MS.high)) MS.high <- ListToMatrix(MS.high)
if (is.list(MS.block)) MS.block <- ListToMatrix(MS.block)

MSscale <- MS.scale

theta0 <- as.matrix(theta0);
theta.dim <- dim(theta0);
r <- theta.dim[1];
c <- theta.dim[2];
#theta0 <- as.vector(theta0);
theta.len <- length(theta0);
theta.i <- !is.na(theta0);
rr <- sum(theta.i);

MSsize <- MS.size;
MSthin <- MSsize[3];
MSsize[3] <- MSsize[2]*MSsize[3];

MSadj  <- MS.adj;


MSblock <- ExE(MS.block,c(r,c))
MSblock <- 0*theta0+MSblock;

MSscale <- ExE(MS.scale,c(r,c))
MSscale <- 0*theta0+MSscale;

MSlow <- ExE(MS.low,c(r,c))
MSlow <- 0*theta0+MSlow

MShigh<- ExE(MS.high,c(r,c))
MShigh <- 0*theta0+MShigh


low.any <- any(!is.na(MSlow));
high.any <- any(!is.na(MShigh));


MSlow[is.na(MSlow)] <- -1E300
MShigh[is.na(MShigh)] <- +1E300

#       block numbers
MSblock.i <- unique(MSblock[!is.na(MSblock)]);
MSblock.i <- MSblock.i[MSblock.i!=0];
MSblock.num     <- length(MSblock.i);

MSblock.i1 <- MSblock.i[MSblock.i>0];
MSblock.num1    <- length(MSblock.i1);

# indicator matrices for the b blocks
MSblock.e <- matrix(0,theta.len,MSblock.num1);
MSblock.ee <- numeric(0);
sss <- seq(1,theta.len);

for (b in MSblock.i1)
{
        MSblock.e[,b] <- (MSblock == b);
        sss.e <- sss[MSblock.e[,b]==1];
        sss.e <- sss.e[!is.na(sss.e)];
        MSblock.ee[b] <- min(sss.e);
}


counter <- 0
save.counter <- 0;
theta.old <- theta0;
#print(is.list(theta.old))

if (software == "R")
loglik.old   <- sum(eval.parent(call(loglik,theta.old,data)))
else if (software == "Splus")
loglik.old   <- sum(eval(call(loglik,theta.old,data)))


loglik.max <- loglik.old;
loglik.mean <- 0;
mle <- theta.old;

if (software == "R")
logpost.old <- loglik.old+sum(eval.parent(call(logprior,theta.old)))
else if (software == "Splus")
logpost.old <- loglik.old+sum(eval(call(logprior,theta.old)))

logpost.max <- logpost.old;
mpe <- theta.old;
postmean <- 0;
post2mom <- 0;

accept0 <- matrix(0,r,c);
accept0 <- 0*theta0+accept0;
accept <- accept0;
acceptall <- accept0;

if (software=="R")
        phi <- eval.parent(call(trans,theta0,data))
else if (software == "Splus")
        phi <- eval(call(trans,theta0,data))


if (is.list(phi))       {
phiLength <- length(phi)
ssample <- list()
for (j in 1:phiLength)          {
ssample[[j]] <- matrix(NA,nrow=MSsize[2],ncol=length(phi[[j]]))
                                }
names(ssample) <- MS.names
                        }

else      {

ssample <- matrix(0,nrow=MSsize[2],ncol=length(phi[!is.na(phi)]))
if (all(is.na(MS.names)))                            {
MS.names <- paste("theta",seq(1,ncol(ssample)),sep="")
dimnames(ssample)[[2]] <- MS.names
                                                }
                                        }

postmat <- matrix(0,nrow=MSsize[2]+floor(MSsize[1]/MSthin)+1,2);
pm1 <- dim(postmat)[1]
postmat <- cbind(postmat,rev(seq(MSsize[2],by=-1,length=pm1)))
postmat <- cbind(postmat,postmat[,3]*MSthin)
timing0 <- proc.time()[3];
timing00 <- timing0;

#       start of sampler
for (mh in -MSsize[1]:MSsize[3])
{

timing1 <- proc.time()[3];
if (timing1-timing0 > 12)
{
cat("\n",
"iteration",mh,"/",MSsize[3],",    save no.",save.counter,"of",MSsize[2],
",     remaining time [min]  ",
round( (timing1-timing00)*( (MSsize[1]+MSsize[3]) / (mh+MSsize[1])-1 ) / 60,dig=1),"\n");
cat("acceptance rate(s) per block ")
if (mh<0 & mh>-MSsize[1])
{ cat( round( acceptall[MSblock.ee]/(MSsize[1]+mh),3) ,"\n") }
if (mh>0)
{ cat( round( acceptall[MSblock.ee]/mh,3) ,"\n")}
cat(
"log-likelihood, log-posterior, log-prior: ","\n",
"  actual:   ",loglik.old,logpost.old,logpost.old-loglik.old,"\n",
"  maxima:   ",loglik.max,logpost.max,"\n");


if (software=="R")
phi <- eval.parent(call(trans,theta.old,data))
else if (software == "Splus")
phi <- eval(call(trans,theta.old,data))


#cat("actual parameters","\n")



if (is.matrix(phi)) phi <- as.vector(phi)

if (is.vector(phi))
{
  phi <- phi[!is.na(phi)]
  if (is.character(MS.names))
  names(phi) <- MS.names

 if ( !all(is.na(MS.screen)) ) print(phi[MS.screen],digits=MS.screen.dig)
 else                   print(phi,digits=MS.screen.dig)

}



#cat(
#"scaling values","\n",
#MSscale[!is.na(MS.scale)],"\n","\n");
timing0 <- timing1;
}

#       scan through blocks


MSblock.rnd <- MSblock.i[ rank(runif(MSblock.num) )];        # random block order

#print(MSblock.rnd);

for (b in MSblock.rnd)
{


if (b>0)
{

	#       new proposal for block b
theta.new <- theta.old + rnorm(theta.len,0,MSscale);
theta.new <- MSblock.e[,b]*theta.new + (1-MSblock.e[,b])*theta.old;




#       check for violations of upper or lower bounds

if (low.any | high.any)
{

e1 <- theta.new<MSlow;
e1[is.na(e1)] <- 0;

e2 <- theta.new>MShigh;
e2[is.na(e2)] <- 0;


while (any(e1) | any(e2))
{

#cat("\n");
e1 <- theta.new<MSlow;
e1[is.na(e1)] <- 0;

if (any(e1))
theta.new <- (1-e1)*theta.new+e1*(2*MSlow-theta.new);
#cat(theta.new,"\n");


e2 <- theta.new>MShigh;
e2[is.na(e2)] <- 0;

if (any(e2))
theta.new <- (1-e2)*theta.new+e2*(2*MShigh-theta.new);



e1 <- theta.new<MSlow;
e1[is.na(e1)] <- 0;
e2 <- theta.new>MShigh;
e2[is.na(e2)] <- 0;
#cat(e1,"\n",e2,"\n",any(e1),any(e2),"\n");
}
}


#cat(mh,theta.new,"\n");

if (software=="R")
loglik.new  <- sum(eval.parent(call(loglik,theta.new,data)))
else if (software == "Splus")
loglik.new  <- sum(eval(call(loglik,theta.new,data)))


if(is.na(loglik.new)) loglik.new <- -1E+300
#print(c(loglik.new,loglik.max,is.na(loglik.new)))

if (software=="R")
logpost.new <- loglik.new+sum(eval.parent(call(logprior,theta.new)))
else if (software == "Splus")
logpost.new <- loglik.new+sum(eval(call(logprior,theta.new)))

if (loglik.new > loglik.max)    { mle <- theta.new; loglik.max <- loglik.new; }
if (logpost.new > logpost.max)  { mpe <- theta.new; logpost.max <- logpost.new; };


#       check acceptance

if( runif(1) < exp(logpost.new-logpost.old) )
{
accept <- accept+MSblock.e[,b];
acceptall <- acceptall + MSblock.e[,b];

theta.old       <- theta.new;
#cat(b,logpost.new,logpost.old,theta.old[1:6],"\n");
loglik.old      <- loglik.new;
logpost.old     <- logpost.new;
}

} # end of b>0


if (b<0)
{
if (software=="R")
theta.new <- eval.parent(call(gibbs,theta.old,data,b))
else if (software == "Splus")
theta.new <- eval(call(gibbs,theta.old,data,b))

if (software=="R")
loglik.new  <- sum(eval.parent(call(loglik,theta.new,data)))
else if (software == "Splus")
loglik.new  <- sum(eval(call(loglik,theta.new,data)))

if ( loglik.new==-Inf | is.na(loglik.new))
{loglik.new <- loglik.old; theta.new <- theta.old};

if (software=="R")
logpost.new <- loglik.new+sum(eval.parent(call(logprior,theta.new)))
else if (software == "Splus")
logpost.new <- loglik.new+sum(eval(call(logprior,theta.new)))

if (loglik.new > loglik.max)    { mle <- theta.new; loglik.max <- loglik.new; }
if (logpost.new > logpost.max)  { mpe <- theta.new; logpost.max <- logpost.new; };

theta.old <- theta.new;loglik.old <- loglik.new;
logpost.old <- logpost.new;
}
# end of b<0;





}
#       end of scan through blocks


if (mh>0)
{
postmean        <- ((mh-1)*postmean+theta.old)/mh;
post2mom        <- ((mh-1)*post2mom+theta.old*theta.old)/mh;
loglik.mean     <- ((mh-1)*loglik.mean+loglik.old)/mh;
}


if (mh>-MSsize[1] & mh <=0 & mh%%MSadj==0 )
{
MSscale <- MSadjust(MSscale,accept/MSadj,0.3)
eee <- MSscale > (MShigh-MSlow)/2
MSscale <- (1-eee)*MSscale + eee*(MShigh-MSlow)/2
accept <- accept0;
}


if (mh==0) acceptall <- accept0;

#if (mh>0 & mh%%MSadj==0 )
#{
#MSscale <- MSadjust(MSscale,accept/MSadj,0.3);
#accept <- accept0;
#}


if (mh%%MSthin==0)      {
        counter <- counter+1
        postmat[counter,1] <- loglik.old;
        postmat[counter,2] <- logpost.old;
}



if (mh>0 & mh%%MSthin==0)
{
        save.counter <- save.counter + 1;
if (software=="R")
        phi.save <- eval.parent(call(trans,theta.old,data))
else if (software == "Splus")
      	phi.save <- eval(call(trans,theta.old,data))


        if (is.list(phi.save))	{
        for (j in 1:phiLength) {
        ssample[[j]][save.counter,] <- phi.save[[j]]
        }
        }

        else	  {
        ssample[save.counter,] <- phi.save[!is.na(phi.save)]
        }

        #postmat[save.counter,1] <- loglik.old;
        #postmat[save.counter,2] <- logpost.old;

}

}

if (is.list(ssample)) names(ssample) <- MS.names

if (software=="R") {
mle.trans <- eval.parent(call(trans,mle,data))
mpe.trans <- eval.parent(call(trans,mpe,data))
meanpe.trans  <- eval.parent(call(trans,postmean,data))
}
else if (software == "Splus")
{
mle.trans <- eval(call(trans,mle,data))
mpe.trans <- eval(call(trans,mpe,data))
meanpe.trans  <- eval(call(trans,postmean,data))
}

Dbar <- -2*loglik.mean
Dhat.mle <- -2*loglik.max

if (software=="R") {
Dhat.mpe <- -2*eval.parent(call(loglik,mpe,data))
Dhat.meanpe <- -2*eval.parent(call(loglik,postmean,data))
}
else if (software == "Splus")
{
Dhat.mpe <- -2*eval(call(loglik,mpe,data))
Dhat.meanpe <- -2*eval(call(loglik,postmean,data))
}

deviance <- list(Dbar=Dbar,Dhat.mle=Dhat.mle,Dhat.mpe=Dhat.mpe,Dhat.meanpe=Dhat.meanpe)

mle <- MatrixToList(mle)
mpe <- MatrixToList(mpe)
meanpe <- MatrixToList(postmean)

Output=list(theta.last=theta.old,MS.scale=MSscale)

mle.mpe <- list(mle=mle,mpe=mpe,meanpe=meanpe,mle.trans=mle.trans,mpe.trans=mpe.trans,meanpe.trans=meanpe.trans)


return(list(Sample=ssample,LoglikLogpostSample=postmat,Estimates=mle.mpe,Deviance=deviance,Input=Input,Output=Output))

#       end of MS sampler
}



MSoutput <- function(savemat,probs=c(0.025,0.50,0.975),names=NULL)
{
if (is.vector(savemat))
savemat <- matrix(savemat,length(savemat))
outsum <- matrix(0,dim(savemat)[2],5);
for (i in 1:dim(savemat)[2])
{
qnt <- quantile(savemat[,i],probs=c(0.025,0.50,0.975));
outsum[i,1] <- mean(savemat[,i]);
outsum[i,2] <- sqrt(var(savemat[,i]));
outsum[i,3:5] <- qnt;
}
names2 <- c(c("mean", "st.dev"),names(qnt));
dimnames(outsum) <- list(names,names2);
return(outsum);
}

MSgraph <- function(tracemat,names=NULL,xlab="iteration",mfrow.par=c(2,2),lwd=1)       {
par(mfrow=mfrow.par)
for (j in 1:ncol(tracemat)) {
if(is.null(names)) yl <- ""
else yl <- names[j]
plot(tracemat[,j],type="l",ylab=yl,xlab=xlab,lwd=lwd)
}
}



MSadjust <-  function(scale,actual,target)
{
e <- actual < 0.5;
factor <-       e*(9-14*target)/(9-14*actual)+(1-e)*(9-14*target)/(2-4*(actual-0.5));
factor[factor<0.01] <- 0.01;
factor[factor>10] <- 10;
scale <- factor*scale;
return(scale)
}

MStrans0 <- function(theta,x) return(theta)



covgroups <- function(nam1,nam2)
{

if (length(nam1) != length(nam2)) stop("incompatible lengths for names1 and names2")
	
cov.length <- rep(0,length(nam1))

for (i in 1:length(nam1))
cov.length[i] <- length(nam2[[i]])	

cov.num <- length(nam1)

groups <- matrix(0,prod(cov.length),length(nam1))
indices <- groups;

for (i in 1:(cov.num-1))
{
print(i)
groups[,i] <- rep(nam2[[i]],rep(prod(cov.length[(i+1):cov.num]),cov.length[i]) )
indices[,i] <- rep(seq(1:cov.length[i]),rep(prod(cov.length[(i+1):cov.num]),cov.length[i]) )
}
groups[,cov.num] <- nam2[[cov.num]]
indices[,cov.num] <- seq(1:cov.length[cov.num])

return(groups,indices)
}


dlogconcave <- function(d,d2)
# parametrization with last a = 0
{
d1 <- c(d,d+cumsum(d2));
a <- c(rev(-cumsum(rev(d1))),0);
#cat(a,"\n");
#cat(d1,"\n");
#cat(d2,"\n");
p <- exp(a)/sum(exp(a));
}


# ExE: expands a vector A to matrix of dimenson dim
ExE <- function(A,dim) {
if (is.matrix(A)) R <- A
if (is.vector(A)) {
if (length(A)==dim[2])	 	R <- matrix(A,dim[1],dim[2],byrow=T)
if (length(A)==dim[1]) 		R <- matrix(A,dim[1],dim[2])
if (length(A)==1)		 		R <- matrix(A,dim[1],dim[2])
}
return(R)
}




#ExE <- function(a,dim1,dim2)
#{
#if (dim(a)[1] == dim1)
#a <- matrix(a,dim1,dim2) else
#a <- matrix(a,dim1,dim2,byrow=T)
#return(a)
#}


N.dsc <- function(x,m,s)
{
if (is.vector(x))
{
nr <- length(x);
xx1 <- x[1:nr-1];
xx2 <- x[2:nr];
values <-  pnorm(xx2,m,s)-pnorm(xx1,m,s);
values <- c(pnorm(x[1],m,s),values);
values <- c(values,1-sum(values));
}
if (is.matrix(x))
{
xx1 <- x[,1]
xx2 <- x[,2]
values <-  pnorm(xx2,m,s)-pnorm(xx1,m,s);
}
return(values)
}



#
# WEIBULL
#

Wb.ms.ab <- function(alpha,beta,paratype=0)
{
if (paratype!=0)
{
a1 <- log(-log(1-paratype[2]));
a2 <- log(-log(1-paratype[1]));
b1 <- log(beta);
b2 <- log(alpha);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));
alpha <- a1/(b1-log(beta));
}
m <- beta*gamma(1+1/alpha);
s <- sqrt( beta^2*gamma(1+2/alpha)-m^2 );
return(m,s);
}


Wb.cdfi <- function(p,alpha,beta,paratype=0)
{
if (paratype!=0)
{
a1 <- log(-log(1-paratype[2]));
a2 <- log(-log(1-paratype[1]));
b1 <- log(beta);
b2 <- log(alpha);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));
alpha <- a1/(b1-log(beta));
}
beta*( ( (-log(1-p))^(1/alpha) )) ;
}

#print(Wb.cdfi(0.2,5,2));

Wb.d <- function(x,alpha,beta,paratype=0)
{
if (paratype!=0)
{
a1 <- log(-log(1-paratype[2]));
a2 <- log(-log(1-paratype[1]));
b1 <- log(beta);
b2 <- log(alpha);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));
alpha <- a1/(b1-log(beta));
}
alpha/(beta^(alpha))*x^(alpha-1)*exp(-(x/beta)^alpha);
}

#x <- seq(0.1,10,by=0.1);
#plot(x,Wb.d(x,3,2),type="l");

Wb.cdf <- function(x,alpha,beta,paratype=0)
{
if (paratype!=0)
{
a1 <- log(-log(1-paratype[2]));
a2 <- log(-log(1-paratype[1]));
b1 <- log(beta);
b2 <- log(alpha);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));
alpha <- a1/(b1-log(beta));
}
1-exp(-(x/beta)^alpha);
}

Wb.cdfc <- function(x,alpha,beta,paratype=0)
{
if (paratype!=0)
{
a1 <- log(-log(1-paratype[2]));a2 <- log(-log(1-paratype[1]));
b1 <- log(beta);
b2 <- log(alpha);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));alpha <- a1/(b1-log(beta));
}
exp(-(x/beta)^alpha);
}

Wb.ll <- function(x,alpha,beta,paratype=0)
{
if (length(paratype)==0)
{
a1 <- log(-log(1-paratype[2]));a2 <- log(-log(1-paratype[1]));
b1 <- log(beta);
b2 <- log(alpha);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));
alpha <- a1/(b1-log(beta));
}
log(alpha)-alpha*log(beta)+(alpha-1)*log(x)-(x/beta)^alpha;
}

Wb.dsc <- function(x,a,b,paratype=0)
{
alpha <- a; beta <- b;
if (length(paratype)==2)
{
a1 <- log(-log(1-paratype[2]));
a2 <- log(-log(1-paratype[1]));
b1 <- log(b);
b2 <- log(a);
beta <- exp( (a2*b1-a1*b2)/(a2-a1));
alpha <- a1/(b1-log(beta));
}
#cat(alpha,beta);
if (is.vector(x))
{
nr <- length(x);
xx1 <- x[1:nr-1];
xx2 <- x[2:nr];
values <-  Wb.cdf(xx2,alpha,beta,0)-Wb.cdf(xx1,alpha,beta,0);
values <- c(Wb.cdf(x[1],alpha,beta,0),values);
values <- c(values,1-sum(values));

}
if (is.matrix(x))
{
xx1 <- x[,1]
xx2 <- x[,2]
values <-  Wb.cdf(xx2,alpha,beta,0)-Wb.cdf(xx1,alpha,beta,0);
}
return(values)
}

#print(Wb.dsc(seq(1,3),2,3));






#
# LOG-NORMAL
#
# LN.cdfi
# LN.cdf
# LN.cdfc
# LN.d
# LN.ll
# LN.dsc
#
#



LN.cdfi <- function(p,mu,sigma,paratype=0)
{

if (paratype==1)
{
m <- mu;
s <- sigma;
ms <- LN.ab.ms(mu,sigma);
mu <- ms$mu;
sigma <- ms$sigma;
}
exp(qnorm(p,mu,sigma))
}


LN.cdf <- function(y,mu,sigma,paratype=0)
{
if (paratype==1)
{
m <- mu;
s <- sigma;
ms <- LN.ab.ms(mu,sigma);
mu <- ms$mu;
sigma <- ms$sigma;
}
pnorm(log(y),mu,sigma) }


#cat(LN.cdf(exp(1.96),0,1));


LN.cdfc <- function(y,mu,sigma,paratype=0)
{
if (paratype==1)
{
m <- mu;
s <- sigma;
ms <- LN.ab.ms(mu,sigma);
mu <- ms$mu;
sigma <- ms$sigma;
}
1-pnorm(log(y),mu,sigma) }

#cat(LN.cdfc(exp(1.96),0,1));


LN.d <- function(x,mu,sigma,paratype=0)
{
if (paratype==1)
{
m <- mu;
s <- sigma;
ms <- LN.ab.ms(mu,sigma);
mu <- ms$mu;
sigma <- ms$sigma;
}
1/(sqrt(2*pi)*sigma*x)*exp(-0.5*(log(x/exp(mu))/sigma)^2)
}


#t <- seq(0.01,10,by=0.01);
#ddd <- LN.d(t,0,1);
#plot(t,ddd,type="l");



LN.ll <- function(x,mu,sigma,paratype=0)
{
if (paratype==1)
{
m <- mu;
s <- sigma;
ms <- LN.ab.ms(mu,sigma);
mu <- ms$mu;
sigma <- ms$sigma;
}
-0.5*log(2*pi)-log(sigma)-log(x)-0.5*(log(x/exp(mu))/sigma)^2;
}

#t <- seq(1,3);
#cat(LN.d(t,0,1));
#cat(exp(LN.ll(t,0,1)));


LN.dsc <- function(x,mu,sigma,paratype=0)
{
if (paratype==1)
{
m <- mu;
s <- sigma;
ms <- LN.ab.ms(mu,sigma);
mu <- ms$mu;
sigma <- ms$sigma;
}

if (is.vector(x))
{
nr <- length(x);
xx1 <- x[1:nr-1];
xx2 <- x[2:nr];
values <-  LN.cdf(xx2,mu,sigma)-LN.cdf(xx1,mu,sigma);
values <- c(LN.cdf(x[1],mu,sigma),values);
values <- c(values,1-sum(values));
}
if (is.matrix(x))
{
xx1 <- x[,1]
xx2 <- x[,2]
values <-  LN.cdf(xx2,mu,sigma)-LN.cdf(xx1,mu,sigma);
}
return(values)
}



#cat(LN.dsc(c(1,2,3,4),0,1),"\n");
#cat(sum(LN.dsc(seq(0.5,5,by=0.5),0,1)));

LN.ab.ms <- function(m,s)
{
mu <- log(m^2)-0.5*log(m^2+s^2);
sigma <- sqrt(log( (s^2+m^2)/(m^2) ) );
return(mu,sigma);
}










mu <- c(1000,200);
Sigma <- matrix(c(40,10,10,60),2,2);

# FOR MULTINOMIAL
#> p <- c(0.0, 0.2, 0.5, 1);
#> table(cut(runif(1000),p))
# 0.0+ thru 0.2 0.2+ thru 0.5 0.5+ thru 1.0
#           186           293           521




r.dir <- function(alpha)
# simulates Dirichlet random vectors for each column of alpha
# repeat alpha n times (column by column) to get n realizations from the same
# Dirichlet(alpha) distribution
# Examples:
# 1) r.dir(matrix(c(1,2,3),3,1000)) to obtain 1000 Dirichlet vectors from a=(1,2,3)
# 2) r.dir(cbind(c(1,2,3),c(10,20,30))) to obtain two Dirichlet vectors, from a1=(1,2,3)
#		and a2=c(10,20,30)

{
if (is.matrix(alpha))
{
ar <- nrow(alpha); ac <- ncol(alpha);
x <- rgamma(ar*ac,alpha);
x <- matrix(x,ar,ac);
x <- t(x)/sumc(x);
x <- t(x);
}
else
{
x <- rgamma(length(alpha),alpha)
x <- x/sum(x);
}
return(x);
}




ll.mvnorm <- function(x,mu,Sigma,cholesky=F)
{
p <- ncol(x);	
n <- nrow(x);
x0 <- t(x)-mu;
if (cholesky==F) { ch <- chol(Sigma)}
	if (cholesky==T) { ch <- Sigma }
chinv <- solve(ch);
d <- prod(diag(chinv));
ll <- -0.5*sumc((t(chinv)%*%x0)^2)+log(abs(d))-p/2*log(2*pi);
return(ll);
}


meanc <- function(x)
{
	n <- nrow(x);
	k <- ncol(x);
	x <- cumsum(x);
	ix <- seq(n,length=k,by=n);
	x <- c(0,x[ix]);
	y <- x[2:(k+1)]-x[1:k];
	return(y/n);
}

sumc <- function(x)
{	n <- nrow(x);
	k <- ncol(x);
	x <- cumsum(x);
	ix <- seq(n,length=k,by=n);
	x <- c(0,x[ix]);
	y <- x[2:(k+1)]-x[1:k];
	return(y);
}


meanr <- function(x)
{
	x <- t(x);
	n <- nrow(x);
	k <- ncol(x);
	x <- cumsum(x);
	ix <- seq(n,length=k,by=n);
	x <- c(0,x[ix]);
	y <- x[2:(k+1)]-x[1:k];
	return(y/n);
}

sumr <- function(x)
{
	x <- t(x);
	n <- nrow(x);
	k <- ncol(x);
	x <- cumsum(x);
	ix <- seq(n,length=k,by=n);
	x <- c(0,x[ix]);	y <- x[2:(k+1)]-x[1:k];
	return(y);
}








r.binom <- function(m,p)
{
k <- length(m);
p <- rep(p,m);
n <- sum(m);
x <- runif(n)<=p;
x <- cumsum(x);
ix <- cumsum(m);
x <- c(0,x[ix]);
return(x[2:(k+1)]-x[1:k]);
}

r.wishart <- function( n=1, R=diag(2), rho=2,verify=F)
{
cat("rwishart - Wishart Random Numbers\n")	
if (!is.matrix(R)) { stop("R is no matrix.\n")}
d <- nrow (R);
L <- chol (R);	
Y <- diag(d);
yr <- row(Y);
yc <- col(Y);
under.diag <- (yc<yr);
on.diag <- (yr==yc);
Y <- array(Y,c(d,d,n));
under.diag.3d <- array(under.diag,c(d,d,n));	
rdim <- round(n*d*(d-1)/2);

if (rdim>1)
{Y[under.diag.3d] <- rnorm(rdim) }

for (i in 1:d)
	Y[i,i,] <- sqrt(rchisq(n,rho-i+1))
	
	W <- array(NA,dim(Y))
	for (i in 1:(dim(W)[3]))
	{
		tmp <- t(L) %*% Y[,,i]; W[,,i] <- tmp %*% t(tmp)
	}
	
		if (n==1) { W <- W[,,1] }
return(W);
}

r.mvnorm <- function(n,mu=c(0,0),cova=diag(length(mu)),cholesky=F)
{
# cholesky decomposition is the upper triangular matrix such that A'A = Sigma	
if (cholesky==F) { cova <- chol(cova) }
p <- length(mu);		
y0 <- matrix(rnorm(n*p),p,n);
y <- t(cova)%*%y0;
y <- y + mu;
y <- t(y);
return(y);
}

#ll.mvnorm <- function(x,mu,Sigma,cholesky=F)
#{
#p <- ncol(x);	
#n <- nrow(x);
#x0 <- t(x)-mu;
#if (cholesky==F) { ch <- chol(Sigma)}
#	if (cholesky==T) { ch <- Sigma }
#chinv <- solve(ch);
#d <- prod(diag(chinv));
#ll <- -0.5*sum((chinv%*%x0)^2)+n*( log(abs(d))-p/2*log(2*pi));
#return(ll);
#}


ListToMatrix <- function(A,fill=NA)	{
#	A is a list with vectors of different lenghts
#	ListToMatrix creates a matrix with vector elements in columns 1,2,3...
#	the remaining values in each columns are filled with NA

M <- A[!is.na(A)]

if (is.list(A)) {

Alen <- length(A)
Au <- unlist(A)

L <- unlist(lapply(A,length))
Lmax <- max(L)


index1 <- lapply(A,function(x) seq(1,length(x)))
index1


index2 <- unlist(index1)+ rep(seq(0,len=Alen,by=Lmax),L)

V <- rep(fill,Lmax*Alen)
V[index2] <- Au

M <- matrix(V,Lmax,Alen)
}

if (is.character(names(A)))
	dimnames(M)[[2]] <- names(A)
return(M)
}

A <- list(1,c(20,30),4,c(50,60,100))
names(A) <- c("X1","X2","X3","X4")


M <- ListToMatrix(A,fill=NA)
M


MatrixToList <- function(M) {
L <- M[!is.na(M)]
if (is.matrix(M)) {
Mcol <- ncol(M)
L <- list()
for (j in 1:Mcol) {
Lj <- M[,j]
L[[j]] <- Lj[!is.na(Lj)]
	}
}
if (is.character(dimnames(M)[[2]]))
	names(L) <- dimnames(M)[[2]]
return(L)
}

MatrixToList(M)

qqnormCompare <- function(x,CompareNum=10,pch=1,lty=2,ylab="")	{
n <- length(x)
m <- mean(x)
s <- sqrt(var(x))
Compare <- matrix(rnorm(CompareNum*n,m,s),n,CompareNum)
if (ylab== "")
qqnorm(x,pch=pch)
else
qqnorm(x,pch=pch,ylab=ylab)

for (j in 1:CompareNum) {
qq1 <- qqnorm(Compare[,j],plot=F)
o <- order(qq1[[1]])
lines(qq1[[1]][o],qq1[[2]][o],lty=lty)
}
}



rDirichlet <- function(n,alpha)
{
		x <- rgamma(n*length(alpha), alpha)
		x <- matrix(x,ncol=n)
		x <- t(x)/sumc(x)
}

error.bar <- function(x, y = NULL, lower, upper, incr = T, bar.ends = T, gap = T, add = F, horizontal = F, ..., xlab = deparse(substitute(x)), xlim, ylim)
{
	draw.null.warn <- function(draw, gap)
	{
		if(!any(draw)) {
			warning("Not enough room for a gap.")
			draw <- !draw
			gap <- 0
		}
		invisible(list(draw = draw, gap = gap))
	}
	if(missing(x))
		stop("no data for x or y")
	if(missing(y)) {
		if(missing(xlab))
			xlab <- "Index"
		y <- x
		x <- time(x)
	}
	n <- length(x)
	if(length(y) != n)
		stop("length of y must equal the length of x")
	center <- if(horizontal) x else y
	if(missing(lower))
		stop("you must provide lower")
	if(length(lower) > 1 && length(lower) != n)
		stop("length of lower must be 1 or equal to the length of x")
	#if incr=T lower is assumed >=0
	if(incr) lower <- center - abs(lower) else lower <- rep(lower, length = n)
	if(any(lower >= center))
		warning(paste("There are values of 'lower' which are greater or equal to ", if(horizontal) "x" else "y"))
	if(missing(upper))
		upper <- 2 * center - lower
	else {
		if(length(upper) > 1 && length(upper) != n)
			stop("length of upper must be 1 or equal to the length of x")
		if(incr)
			upper <- center + upper
		else upper <- rep(upper, length = n)
	}
	if(any(upper <= center))
		warning(paste("There are values of 'upper' which are smaller or\nequal to ", if(horizontal) "x" else "y"))
	if(!add)
		if(horizontal) {
			if(missing(ylim))
				plot(x, y, xlim = if(missing(xlim)) range(c(lower, upper), na.rm = T) else xlim, xlab = xlab, ...)
			else plot(x, y, xlim = if(missing(xlim)) range(c(lower, upper), na.rm = T) else xlim, ylim = ylim, xlab = xlab, ...)
		}
		else {
			if(missing(xlim))
				plot(x, y, ylim = if(missing(ylim)) range(c(lower, upper), na.rm = T) else ylim, xlab = xlab, ...)
			else plot(x, y, ylim = if(missing(ylim)) range(c(lower, upper), na.rm = T) else ylim, xlim = xlim, xlab = xlab, ...)
		}
	if(horizontal) {
		if(gap)
			gap <- 0.75 * par("cxy")[1]
		draw <- x - lower > gap
		z <- draw.null.warn(draw, gap)
		draw <- z$draw
		gap <- z$gap
		segments(lower[draw], y[draw], x[draw] - gap, y[draw])
		draw <- upper - x > gap
		z <- draw.null.warn(draw, gap)
		draw <- z$draw
		gap <- z$gap
		segments(x[draw] + gap, y[draw], upper[draw], y[draw])
		if(bar.ends) {
			size.bar <- par("cxy")[2]
			segments(lower, y - size.bar, lower, y + size.bar)
			segments(upper, y - size.bar, upper, y + size.bar)
		}
	}
	else {
		if(gap)
			gap <- 0.75 * par("cxy")[2]
		draw <- upper - y > gap
		z <- draw.null.warn(draw, gap)
		draw <- z$draw
		gap <- z$gap
		segments(x[draw], y[draw] + gap, x[draw], upper[draw])
		draw <- y - lower > gap
		z <- draw.null.warn(draw, gap)
		draw <- z$draw
		gap <- z$gap
		segments(x[draw], y[draw] - gap, x[draw], lower[draw])
		if(bar.ends) {
			size.bar <- par("cxy")[1]
			segments(x - size.bar, upper, x + size.bar, upper)
			segments(x - size.bar, lower, x + size.bar, lower)
		}
	}
}


